# Dialogbeispiel.py
## basiert auf 06-GUI-nach-wxButton.py
## der Variante mit eigener Panel-Klasse

import wx

### ---------------------------------------------------
    ### ----- Panel fuer den Frame -----  aus Demo Button
class MeinPanel(wx.Panel):
    def __init__(self, parent):                 # weg: , log
        wx.Panel.__init__(self, parent, -1)
        
        ## Abschnitt aus wxButton ("Default" so sinnlos)
        b = wx.Button(self, 10, "Default Button", (20, 20))
        self.Bind(wx.EVT_BUTTON, self.OnClick, b)
        b.SetDefault()
        b.SetSize(b.GetBestSize())

        ### ----- Ereignisbehandlung -----
        ## Abschnitt aus wxButton
    def OnClick(self, event):
        #self.log.write...
        print("Click! (%d)\n" % event.GetId())

### ---------------------------------------------------
    ### ----- Frame fuer Gui -----  aus Demo Menu
class Gui(wx.Frame):

    def __init__(self, parent, id):       # weg: , log
        wx.Frame.__init__(self, parent, id, 'Gui', size=(500, 250))
        ## einfuegen
        self.panel=MeinPanel(self)

        ## raus self.log = log
        self.CenterOnScreen()

    def CloseWindow(self, event):
        self.Close()



    ### ----- App-Bereich -----
        ## Abschnitt aus Raumplaner-Anfang
### ---------------------------------------------------
class MyApp(wx.App):
    """Anwendung fuer ..."""
    def OnInit(self):
        self.gui = Gui(None, -1)
        self.SetTopWindow(self.gui)
        self.gui.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
        
