# Dialogbeispiel.py
## basiert auf 06-GUI-nach-wxButton.py
## der Variante mit eigener Panel-Klasse
## verwendet aus wxDemo das Beispiel Dialog,
## davon den SampleDialog

import wx

### ---------------------------------------------------
class TestDialog(wx.Dialog):
    def __init__(
            self, parent, id, title, size=wx.DefaultSize, pos=wx.DefaultPosition,
            style=wx.DEFAULT_DIALOG_STYLE, name='dialog'
            ):

        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.
        wx.Dialog.__init__(self)
        self.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        self.Create(parent, id, title, pos, size, style, name)

        # Now continue with the normal construction of the dialog
        # contents
        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "This is a wx.Dialog")
        label.SetHelpText("This is the help text for the label")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Field #1:")
        label.SetHelpText("This is the help text for the label")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        text = wx.TextCtrl(self, -1, "", size=(80,-1))
        text.SetHelpText("Here's some help text for field #1")
        box.Add(text, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        ## Ergänzung:
        self.text1=text

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Field #2:")
        label.SetHelpText("This is the help text for the label")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        text = wx.TextCtrl(self, -1, "", size=(80,-1))
        text.SetHelpText("Here's some help text for field #2")
        box.Add(text, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        ## Ergänzung:
        self.text2=text

        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()

        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cancels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

### ---------------------------------------------------
    ### ----- Panel fuer den Frame -----  aus Demo Button
class MeinPanel(wx.Panel):
    def __init__(self, parent):                 # weg: , log
        wx.Panel.__init__(self, parent, -1)
        
        b = wx.Button(self, 10, "Dialog anzeigen", (20, 20))
        self.Bind(wx.EVT_BUTTON, self.OnButtonClick, b)
        b.SetDefault()
        b.SetSize(b.GetBestSize())

        ### ----- Ereignisbehandlung -----
    def OnButtonClick(self, event):
        dlg = TestDialog(self, -1, "Sample Dialog", size=(350, 200),
                         style=wx.DEFAULT_DIALOG_STYLE,
                         )
        dlg.CenterOnScreen()

        # this does not return until the dialog is closed.
        val = dlg.ShowModal()

        if val == wx.ID_OK:
            ##self.log.WriteText("You pressed OK\n")
            print("OK angeklickt")
        else:
            ##self.log.WriteText("You pressed Cancel\n")
            print("Cancel angeklickt")

        ## Ergänzung:
        print("Werte sind: ", dlg.text1.GetValue(), dlg.text2.GetValue())

        dlg.Destroy()

### ---------------------------------------------------
    ### ----- Frame fuer Gui -----  aus Demo Menu
class Gui(wx.Frame):

    def __init__(self, parent, id):       # weg: , log
        wx.Frame.__init__(self, parent, id, 'Gui', size=(500, 250))
        ## einfuegen
        self.panel=MeinPanel(self)

        ## raus self.log = log
        self.CenterOnScreen()

    def CloseWindow(self, event):
        self.Close()



    ### ----- App-Bereich -----
        ## Abschnitt aus Raumplaner-Anfang
### ---------------------------------------------------
class MyApp(wx.App):
    """Anwendung fuer ..."""
    def OnInit(self):
        self.gui = Gui(None, -1)
        self.SetTopWindow(self.gui)
        self.gui.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
        
