# konfigurationsDialog.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationsDialog(wx.Dialog):
    def __init__(
            self, parent,ID, title="Konfiguration der Objektdaten",
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        gbs = wx.GridBagSizer(vgap=5, hgap=5) # neu

        ### Label (StaticText) und TextCtrl
        ### Achtung: Erzeugen und Einbau in gbs hier getrennt !!!
        ## Datenbereich
        labelX = wx.StaticText(self, -1, "x-Position")
        self.textX = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelY = wx.StaticText(self, -1, "y-Position")
        self.textY = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelB = wx.StaticText(self, -1, "Breite")
        self.textBreite = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelT = wx.StaticText(self, -1, "Tiefe")
        self.textTiefe = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelW = wx.StaticText(self, -1, "Winkel")
        self.textWinkel = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))
        labelF = wx.StaticText(self, -1, "Farbe")
        self.textFarbe = wx.TextCtrl(self, -1,
                                     "",
                                     size=(125, -1))

        gbs.Add(labelX, (0,0), flag=wx.ALL, border=10)
        gbs.Add(self.textX, (0,1), flag=wx.ALL, border=10)
        gbs.Add(labelY, (1,0), flag=wx.ALL, border=10)
        gbs.Add(self.textY, (1,1), flag=wx.ALL, border=10)
        gbs.Add(labelB, (2,0), flag=wx.ALL, border=10)
        gbs.Add(self.textBreite, (2,1), flag=wx.ALL, border=10)
        gbs.Add(labelT, (3,0), flag=wx.ALL, border=10)
        gbs.Add(self.textTiefe, (3,1), flag=wx.ALL, border=10)
        gbs.Add(labelW, (4,0), flag=wx.ALL, border=10)
        gbs.Add(self.textWinkel, (4,1), flag=wx.ALL, border=10)
        gbs.Add(labelF, (5,0), flag=wx.ALL, border=10)
        gbs.Add(self.textFarbe, (5,1), flag=wx.ALL, border=10)
        
        ## dem vertikalen Sizer hinzufuegen
        sizer.Add(gbs, 0, wx.GROW|wx.ALL, 5)
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, x, y, breite, tiefe, winkel, farbe):
        self.textX.ChangeValue(str(x))
        self.textY.ChangeValue(str(y))
        self.textBreite.ChangeValue(str(breite))
        self.textTiefe.ChangeValue(str(tiefe))
        self.textWinkel.ChangeValue(str(winkel))
        self.textFarbe.ChangeValue(farbe)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

### ---------------------------------------------------
    ### ----- Panel fuer den Frame -----  aus Demo Button
class MeinPanel(wx.Panel):
    def __init__(self, parent):                 # weg: , log
        wx.Panel.__init__(self, parent, -1)
        
        b = wx.Button(self, 10, "Dialog anzeigen", (20, 20))
        self.Bind(wx.EVT_BUTTON, self.OnButtonClick, b)
        b.SetDefault()
        b.SetSize(b.GetBestSize())

        ### ----- Ereignisbehandlung -----
    def OnButtonClick(self, event):
        dlg = KonfigurationsDialog(self, -1, "Konfiguration",# size=(350, 200),
                         style=wx.DEFAULT_DIALOG_STYLE,
                         )
        dlg.CenterOnScreen()

        dlg.DatenSetzen(10,20,120,60,0,"red")

        # this does not return until the dialog is closed.
        val = dlg.ShowModal()

        if val == wx.ID_OK:
            ##self.log.WriteText("You pressed OK\n")
            print("OK angeklickt")
        else:
            ##self.log.WriteText("You pressed Cancel\n")
            print("Cancel angeklickt")

        ## Ergänzung:
        print("Werte sind: ", dlg.textX.GetValue(),
              dlg.textY.GetValue(),
              dlg.textBreite.GetValue(),
              dlg.textTiefe.GetValue(),
              dlg.textWinkel.GetValue(),
              dlg.textFarbe.GetValue()
              )

        dlg.Destroy()

### ---------------------------------------------------
    ### ----- Frame fuer Gui -----  aus Demo Menu
class Gui(wx.Frame):

    def __init__(self, parent, id):       # weg: , log
        wx.Frame.__init__(self, parent, id, 'Gui', size=(500, 250))
        ## einfuegen
        self.panel=MeinPanel(self)

        ## raus self.log = log
        self.CenterOnScreen()

    def CloseWindow(self, event):
        self.Close()



    ### ----- App-Bereich -----
        ## Abschnitt aus Raumplaner-Anfang
### ---------------------------------------------------
class MyApp(wx.App):
    """Anwendung fuer ..."""
    def OnInit(self):
        self.gui = Gui(None, -1)
        self.SetTopWindow(self.gui)
        self.gui.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = MyApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
        

